#include <iostream>
#include "Ones.h"

using namespace std;

Ones::Ones(void)
{
}

Ones::~Ones(void)
{
}

void Ones::doIt(void)
{
	cout << "Enter the number : ";
	int number = 0;
	cin >> number;

	if (0 == (number%2)) 
	{
		cerr << number << " is divided by 2." << endl;
		return;
	}
	if (0 == (number%5)) 
	{
		cerr << number << " is divided by 5." << endl;
		return;
	}
	if (10000 < number) 
	{
		cerr << number << " is bigger then 10000." << endl;
		return;
	}
	if (0 > number) 
	{
		cerr << number << " is less then 0." << endl;
		return;
	}

	cout << "The number is " << number << endl;

	int count = 0;
	int target = 1;
    int a = number % 10; 
	int carry = 0; // number except last 1's
	int allOne = isAllOne(number);
	while (allOne<0) 
	{
        // we try to find {b | a*b = ...XX(target)}.
		int b = numberForTarget(a,target);
		if (-1==b)
		{
			cerr << "Big error!\n";
			return;
		}
		count++; // we make one more '1'
		carry = (number*b+carry)/10;
		target = (11 - carry%10)%10;
		cout << "b=" << b << ", carry=" << carry << ", target=" << target << endl;
		allOne = isAllOne(carry);
//		cin.clear();
//		cin.get();
	}
	count+=allOne;
	cout << "The answer is " << count << endl;
	return;
}

int Ones::doIt(int number)
{
	if (0 == (number%2)) return -1;
	if (0 == (number%5)) return -1;
	if (10000 < number) return -1;
	if (0 > number) return -1;

	int count = 0;
	int target = 1;
    int a = number % 10; 
	int carry = 0; // number except last 1's
	int allOne = isAllOne(number);
	while (allOne<0) 
	{
        // we try to find {b | a*b = ...XX(target)}.
		int b = numberForTarget(a,target);
		if (-1==b)
		{
			cerr << "Big error!\n";
			return -1;
		}
		count++; // we make one more '1'
		carry = (number*b+carry)/10;
		target = (11 - carry%10)%10;
//		cout << "b=" << b << ", carry=" << carry << ", target=" << target << endl;
		allOne = isAllOne(carry);
	}
	count+=allOne;
	return count;
}

int Ones::isAllOne(int number)
{
	switch (number)
	{
	case 1: return 1;
	case 11: return 2;
	case 111: return 3;
	case 1111: return 4;
	case 11111: return 5;
	case 111111: return 6;
	default: return -1;
	}
}

int Ones::numberForTarget(int a, int target)
{
//	cout << a << "," << target << endl;
	for (int i=0;i<10;i++)
		if (target==((i*a)%10)) return i;
	return -1; // ERROR!
}


/**
 * Entry point
 */
int main()
{
	Ones *ones= new Ones();

//	ones->doIt();
	int maxIndex=0;
	int maxNumber=-1;
	for (int i=0;i<=10000;i++)
	{
		int number = ones->doIt(i);
		if (number>0) cout << "i:" << i << ", number:" << number << endl;
		if (number>=maxNumber)
		{
			maxIndex=i;
			maxNumber=number;
		}
	}

	cout << "max i:" << maxIndex << ", max number:" << maxNumber << endl;
	delete ones;
}

